<template>
  <div>
     <article :id="article.id" :key="article.id" class="news-article card" dir="ltr">
      <div class="published-date">{{ article.date.toLocaleDateString(getCurrentShortLocale(), { day: 'numeric', month: 'long', year: 'numeric' }) }}</div>

      <component :is="headingType">
        <router-link :to="'/news/' + article.id">
          <strong>{{ article.title }}</strong>
        </router-link>
      </component>

      <div class="small-separator"></div>

      <!-- eslint-disable-next-line vue/no-v-html -->
      <div class="body" @click="onNewsClick($event)" v-html="overview ? truncatedHTML() : article.html" :class="{ 'truncate-article': overview }"></div>

      <div class="text-end">
        <router-link class="jpt-link fs-5 me-3" v-if="overview" :to="'/news/' + article.id">{{ $gettext('Read more') }}</router-link>
      </div>
    </article>

    <div id="modal" :class="{ 'hide-modal': hideModal }" @click="closeModal()">
      <img loading="lazy" :src="modalImgSrc" />

      <div class="caption">{{ modalCaption }}</div>
    </div>
  </div>
</template>

<script>
  import { defineComponent } from 'vue'

  export default defineComponent({
    props: {
      article: Object,
      overview: Boolean,
      headingType: {
        type: String,
        default: 'h3'
      }
    },

    data: function () {
      return {
        modalImgSrc: '',
        modalCaption: '',
        hideModal: true
      }
    },

    methods: {
      onNewsClick (event) {
        if (event.target instanceof HTMLImageElement) {
          if (event.target.parentElement instanceof HTMLAnchorElement) return

          return this.openModal(event)
        }
      },

      openModal (event) {
        const img = event.target

        this.hideModal = false
        this.modalImgSrc = img.src
        this.modalCaption = img.alt
      },

      closeModal () {
        this.hideModal = true
        this.modalImgSrc = ''
        this.modalCaption = ''
      },

      truncatedHTML () {
        const matched = this.article.html.match(/^([^]+?)<h/m)

        return matched ? matched[1] : ''
      }
    }
  })
</script>

<style lang="scss">
  // Not scoped because we want to style generated HTML
  @import '../../scss/_variables.scss';
  @import '../../scss/_mixins.scss';
  @import '../../scss/_bootstrap-mixins.scss';

  @import "bootstrap/scss/tables";

  .news-article {
    @include padding(2rem 2.5rem);

    @include media-breakpoint-down(sm) {
      padding: 20px;
      border-right: none;
      border-left: none;
      border-radius: 0;
    }

    margin: 15px 0;

    .published-date {
      color: $secondary-font-color;
      margin-bottom: 10px;
    }

    h1,
    h3 {
      // For the mascot
      @include media-breakpoint-up(sm) {
        margin-inline-end: 120px;
      }

      a {
        @include disable-default-a-behaviour;

        color: inherit;

        &:hover {
          opacity: 0.8;
        }
      }
    }

    h1 {
      @include font-size(1.75rem);
    }

    .body {
      margin-top: 40px;

      p {
        @include wrap-text;

        margin-bottom: 10px;
      }

      p + *:not(ul),
      ul + *:not(ul) {
        margin-top: 1rem;
      }

      a {
        word-break: break-word;
      }

      h4 {
        @include font-size(1.25rem);

        margin: 0 !important;
        margin-top: 2rem !important;
        margin-bottom: 1rem !important;
      }

      h5 {
        @include font-size(1.125rem);

        margin: 0 !important;
        margin-top: 1.5rem !important;
        margin-bottom: 1rem !important;
      }

      h4,
      h5 {
        font-weight: $font-bold;

        a {
          @include peertube-link;
        }
      }

      img {
        cursor: pointer;
        max-width: 100%;
        height: auto;
      }

      figure {
        margin: 30px auto;
        border: 10px solid $beige-500;
        width: fit-content;

        > a {
          display: block;
          text-align: center;
        }

        figcaption {
          @include font-size-14px;
          @include adapt-link-size-14px;

          background: $beige-500;
          text-align: center;
          padding: 0;
          padding-top: 10px;
        }
      }

      iframe {
        display: block;
        margin-inline-start: auto;
        margin-inline-end: auto;
      }

      .news-card {
        background-color: #FCE8DB;
        border: 1px solid #FFC99E;
        border-radius: 16px;
        padding: 1.25rem;
        margin-bottom: 1rem;
      }

      blockquote {
        background: #fffaf6;
        border-left: 6px solid #FFC99E;
        border-radius: .5rem;
        margin: 1.25rem 0;
        padding: 1.25rem 1.75rem;

        font-size: 1.125rem;
        font-weight: inherit;
        line-height: 1.8;

        &::before {
          background: url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" version="1.0" fill="%23fc8e3a" viewBox="0 0 60 45"><path d="M23.26 4.7c8.13 9.12 2.52 24.97-4.24 31.1-5.75 5.23-15.29 9.5-16.2 8-1.43-2.36 4.21-4.05 8.45-7.86 5.25-5.71 7.04-8.28-.27-11.5-7.82-3.53-7.97-7-8.24-11.4C2.12 1.97 15.35-3.21 23.26 4.7zm30.54.17c8.12 9.1 2.52 24.96-4.24 31.1-5.75 5.22-15.3 9.48-16.2 7.99-1.43-2.38 4.2-4.05 8.44-7.86 5.28-5.71 7.04-8.28-.25-11.51-7.84-3.54-8-7-8.25-11.4-.64-11.06 12.58-16.24 20.5-8.32z"/></svg>') no-repeat;
          content: ' ';
          float: right;
          margin-right: -2rem;
          margin-top: -2rem;
          opacity: 0.4;
          width: 60px;
          height: 45px;
        }
      }
    }
  }

  #modal {
    &.hide-modal {
      display: none;
    }

    position: fixed;
    z-index: 1;
    padding-top: 5vh;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    overflow: auto;
    background-color: rgb(0, 0, 0);
    background-color: rgba(0, 0, 0, 0.9);

    img {
      margin: auto;
      display: block;
      height: auto;
      width: auto;
      max-height: 90%;
    }

    .caption {
      margin: auto;
      display: block;
      width: 80%;
      max-width: 700px;
      text-align: center;
      color: #ccc;
      padding: 10px;
    }

    img,
    .caption {
      animation-name: zoom;
      animation-duration: 0.6s;
    }
  }

  .truncate-article {
    max-height: 200px;

    display: -webkit-box;
    -webkit-line-clamp: 4;
    -webkit-box-orient: vertical;
    overflow: hidden;
  }
</style>
